diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
similarity index 81%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
index e183d743d..9c6035792 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
@@ -4,9 +4,11 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLever;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
 
 public class BlockModelLever<T extends Block> extends BlockModelStandard<T> {
@@ -16,7 +18,6 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         int i1 = l & 15;
         boolean flag = (l & 16) > 0;
@@ -28,32 +29,34 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T> {
         float f = 0.25F;
         float f1 = 0.1875F;
         float f2 = 0.1875F;
-        if(i1 == 7)
-        {
-            block.setBlockBounds(0.5F - f1, 1f - f2, 0.5F - f, 0.5F + f1, 1f, 0.5F + f);
-        } else if(i1 == 8)
-        {
-            block.setBlockBounds(0.5F - f, 1f - f2, 0.5F - f1, 0.5F + f, 1f, 0.5F + f1);
-        } else if(i1 == 5)
-        {
-            block.setBlockBounds(0.5F - f1, 0.0F, 0.5F - f, 0.5F + f1, f2, 0.5F + f);
-        } else if(i1 == 6)
-        {
-            block.setBlockBounds(0.5F - f, 0.0F, 0.5F - f1, 0.5F + f, f2, 0.5F + f1);
-        } else if(i1 == 4)
-        {
-            block.setBlockBounds(0.5F - f1, 0.5F - f, 1.0F - f2, 0.5F + f1, 0.5F + f, 1.0F);
-        } else if(i1 == 3)
-        {
-            block.setBlockBounds(0.5F - f1, 0.5F - f, 0.0F, 0.5F + f1, 0.5F + f, f2);
-        } else if(i1 == 2)
-        {
-            block.setBlockBounds(1.0F - f2, 0.5F - f, 0.5F - f1, 1.0F, 0.5F + f, 0.5F + f1);
-        } else if(i1 == 1)
-        {
-            block.setBlockBounds(0.0F, 0.5F - f, 0.5F - f1, f2, 0.5F + f, 0.5F + f1);
+        AABB bounds = block.getBounds();
+        switch (i1) {
+            case BlockLever.ROTATION_BOTTOM_NS:
+                bounds.set(0.5F - f1, 1f - f2, 0.5F - f, 0.5F + f1, 1f, 0.5F + f);
+                break;
+            case BlockLever.ROTATION_BOTTOM_WE:
+                bounds.set(0.5F - f, 1f - f2, 0.5F - f1, 0.5F + f, 1f, 0.5F + f1);
+                break;
+            case BlockLever.ROTATION_TOP_NS:
+                bounds.set(0.5F - f1, 0.0F, 0.5F - f, 0.5F + f1, f2, 0.5F + f);
+                break;
+            case BlockLever.ROTATION_TOP_WE:
+                bounds.set(0.5F - f, 0.0F, 0.5F - f1, 0.5F + f, f2, 0.5F + f1);
+                break;
+            case BlockLever.ROTATION_NORTH:
+                bounds.set(0.5F - f1, 0.5F - f, 1.0F - f2, 0.5F + f1, 0.5F + f, 1.0F);
+                break;
+            case BlockLever.ROTATION_SOUTH:
+                bounds.set(0.5F - f1, 0.5F - f, 0.0F, 0.5F + f1, 0.5F + f, f2);
+                break;
+            case BlockLever.ROTATION_WEST:
+                bounds.set(1.0F - f2, 0.5F - f, 0.5F - f1, 1.0F, 0.5F + f, 0.5F + f1);
+                break;
+            case BlockLever.ROTATION_EAST:
+                bounds.set(0.0F, 0.5F - f, 0.5F - f1, f2, 0.5F + f, 0.5F + f1);
+                break;
         }
-        renderStandardBlock(tessellator, block, x, y, z);
+        renderStandardBlock(tessellator, bounds, x, y, z);
         if(!flag1)
         {
             renderBlocks.overrideBlockTexture = null;
@@ -62,7 +65,7 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T> {
         if(LightmapHelper.isLightmapEnabled()) {
         	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
         }else {
-			if(Block.lightEmission[block.id] > 0) {
+			if(Blocks.lightEmission[block.id] > 0) {
 				brightness = 1.0f;
 			}else {
 				brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
similarity index 78%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
index df4e575cf..fffb510a0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -19,7 +20,7 @@ public class BlockModelOverlayLeaves<T extends Block> extends BlockModelLeaves<T
         super.render(tessellator, x, y, z);
 
         renderBlocks.overrideBlockTexture = overlayTexture;
-        renderStandardBlock(tessellator, block, x, y, z, 1.0f, 1.0f, 1.0f);
+        renderStandardBlock(tessellator, block.getBoundsRaw(), x, y, z, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = null;
 
         return true;
@@ -29,37 +30,39 @@ public class BlockModelOverlayLeaves<T extends Block> extends BlockModelLeaves<T
         super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
+        AABB bounds = block.getBounds();
+
         IconCoordinate overlayCoord = overlayTexture;
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, overlayCoord);
+        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
 
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
similarity index 81%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
index 173e003cd..a8468b87d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
@@ -20,17 +20,17 @@ public class BlockModelPebbles<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        float f1 = 1.0F;
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	tessellator.setLightmapCoord(LightmapHelper.max(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z), block.getLightmapCoord(renderBlocks.blockAccess, x, y - 1, z)));
         }else {
         	brightness = Math.max(getBlockBrightness(renderBlocks.blockAccess, x, y, z), getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z));
         }
-        tessellator.setColorOpaque_F(f1 * brightness, f1 * brightness, f1 * brightness);
-        IconCoordinate j = getBlockTextureFromSideAndMetadata(Side.TOP, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
-        renderTopFace(tessellator, block, x, y, z, j);
+        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        renderTopFace(tessellator,
+            block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z),
+            x, y, z,
+            getBlockTextureFromSideAndMetadata(Side.TOP, renderBlocks.blockAccess.getBlockMetadata(x, y, z)));
 
         return true;
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
similarity index 67%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
index 842c812d8..ec7abc70d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
@@ -6,8 +6,9 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockEdible;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 
-public class BlockModelPiePumpkin<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelPiePumpkin<T extends BlockEdible> extends BlockModelStandard<T> {
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/side");
     protected IconCoordinate insideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/inner");
     protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/top");
@@ -19,15 +20,15 @@ public class BlockModelPiePumpkin<T extends Block> extends BlockModelStandard<T>
         withCustomItemBounds(f, 0.0F, f, 1.0F - f, f1, 1.0F - f);
     }
 
-    public void renderSliceSide(Tessellator tessellator, Block block, int x, int y, int z, Side side, boolean overrideTex) {
+    public void renderSliceSide(Tessellator tessellator, AABB bounds, int x, int y, int z, Side side, boolean overrideTex) {
         if(overrideTex)
             renderBlocks.overrideBlockTexture = insideTexture;
-        renderSide(tessellator, block, x, y, z, side, 0);
+        renderSide(tessellator, bounds, x, y, z, side, 0);
         if(overrideTex)
             renderBlocks.overrideBlockTexture = null;
     }
 
-    private void renderSlice(Tessellator tessellator, Block block, int x, int y, int z, int sliceX, int sliceZ) {
+    private void renderSlice(Tessellator tessellator, AABB bounds, int x, int y, int z, int sliceX, int sliceZ) {
 
         double onePix = 0.0625;
         double sliceWidth = onePix * 8;
@@ -47,21 +48,21 @@ public class BlockModelPiePumpkin<T extends Block> extends BlockModelStandard<T>
         boolean insideEast = sliceX == 0 ;
         boolean insideWest = sliceX == 1;
 
-        maxSlices = ((BlockEdible) block).maxBites;
-        block.setBlockBounds(xMin + offsetXMin, 0.0F, zMin + offsetZMin, xMax - offsetXMax, 0.375F, zMax - offsetZMax);
-        renderSide(tessellator, block, x, y, z, Side.TOP, 0);
-        renderSide(tessellator, block, x, y, z, Side.BOTTOM, 0);
-        renderSliceSide(tessellator, block, x, y, z, Side.SOUTH, insideSouth);
-        renderSliceSide(tessellator, block, x, y, z, Side.WEST, insideWest);
+        maxSlices = block.maxBites;
+        bounds.set(xMin + offsetXMin, 0.0F, zMin + offsetZMin, xMax - offsetXMax, 0.375F, zMax - offsetZMax);
+        renderSide(tessellator, bounds, x, y, z, Side.TOP, 0);
+        renderSide(tessellator, bounds, x, y, z, Side.BOTTOM, 0);
+        renderSliceSide(tessellator, bounds, x, y, z, Side.SOUTH, insideSouth);
+        renderSliceSide(tessellator, bounds, x, y, z, Side.WEST, insideWest);
         renderBlocks.flipTexture = true;
-        renderSliceSide(tessellator, block, x, y, z, Side.NORTH, insideNorth);
-        renderSliceSide(tessellator, block, x, y, z, Side.EAST, insideEast);
+        renderSliceSide(tessellator, bounds, x, y, z, Side.NORTH, insideNorth);
+        renderSliceSide(tessellator, bounds, x, y, z, Side.EAST, insideEast);
         renderBlocks.flipTexture = false;
     }
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
 
         final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         renderBlocks.enableAO = true;
@@ -72,7 +73,7 @@ public class BlockModelPiePumpkin<T extends Block> extends BlockModelStandard<T>
                 slices++;
                 if(meta >= slices)
                     continue;
-                renderSlice(tessellator, block, x, y, z, xSlice, zSlice);
+                renderSlice(tessellator, bounds, x, y, z, xSlice, zSlice);
             }
         }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
similarity index 85%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
index 8f3a9caa7..ceb16c3ee 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.piston.BlockPistonBase;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStandard<T> {
@@ -39,7 +40,6 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z){
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         return renderPistonBase(tessellator, x, y, z, false);
     }
 
@@ -53,6 +53,7 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         boolean extended = noCulling || (meta & 8) != 0;
         Direction direction = BlockPistonBase.getDirection(meta);
+        AABB bounds;
         if(extended)
         {
             switch(direction)
@@ -62,17 +63,17 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
                     renderBlocks.uvRotateWest = 3;
                     renderBlocks.uvRotateSouth = 3;
                     renderBlocks.uvRotateNorth = 3;
-                    block.setBlockBounds(0.0F, headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
+                    bounds = AABB.getTemporaryBB(0.0F, headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
                     break;
 
                 case UP: // '\001'
-                    block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1 - headThickness, 1.0F);
+                    bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1 - headThickness, 1.0F);
                     break;
 
                 case NORTH: // '\002'
                     renderBlocks.uvRotateSouth = 1;
                     renderBlocks.uvRotateNorth = 2;
-                    block.setBlockBounds(0.0F, 0.0F, headThickness, 1.0F, 1.0F, 1.0F);
+                    bounds = AABB.getTemporaryBB(0.0F, 0.0F, headThickness, 1.0F, 1.0F, 1.0F);
                     break;
 
                 case SOUTH: // '\003'
@@ -80,7 +81,7 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
                     renderBlocks.uvRotateNorth = 1;
                     renderBlocks.uvRotateTop = 3;
                     renderBlocks.uvRotateBottom = 3;
-                    block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - headThickness);
+                    bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - headThickness);
                     break;
 
                 case WEST: // '\004'
@@ -88,7 +89,7 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
                     renderBlocks.uvRotateWest = 2;
                     renderBlocks.uvRotateTop = 2;
                     renderBlocks.uvRotateBottom = 1;
-                    block.setBlockBounds(headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    bounds = AABB.getTemporaryBB(headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                     break;
 
                 case EAST: // '\005'
@@ -96,12 +97,14 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
                     renderBlocks.uvRotateWest = 1;
                     renderBlocks.uvRotateTop = 1;
                     renderBlocks.uvRotateBottom = 2;
-                    block.setBlockBounds(0.0F, 0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F);
+                    bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F);
                     break;
+
+                default:
+                    bounds = AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
             }
-            renderStandardBlock(tessellator, block, x, y, z);
+            renderStandardBlock(tessellator, bounds, x, y, z);
             resetRenderBlocks();
-            block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         } else
         {
             switch(direction)
@@ -139,7 +142,7 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
                     renderBlocks.uvRotateBottom = 2;
                     break;
             }
-            renderStandardBlock(tessellator, block, x, y, z);
+            renderStandardBlock(tessellator, block.getBounds(), x, y, z);
             resetRenderBlocks();
         }
         return true;
@@ -156,6 +159,7 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
+        AABB bounds = block.getBounds();
         Direction direction = BlockPistonBase.getDirection(data);
         if (direction == Direction.NONE)
         {
@@ -163,7 +167,7 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
         }
         if (side.getDirection() == direction)
         {
-            if (BlockPistonBase.isPowered(data) || block.minX > 0.0D || block.minY > 0.0D || block.minZ > 0.0D || block.maxX < 1.0D || block.maxY < 1.0D || block.maxZ < 1.0D)
+            if (BlockPistonBase.isPowered(data) || bounds.minX > 0.0D || bounds.minY > 0.0D || bounds.minZ > 0.0D || bounds.maxX < 1.0D || bounds.maxY < 1.0D || bounds.maxZ < 1.0D)
             {
                 return topTexture;
             }
